import * as react from 'react';
import Inputmask$1 from 'inputmask';
import { UseFormRegisterReturn } from 'react-hook-form';

interface UseInputMaskOptions {
    mask: Inputmask$1.Options['mask'];
    register?(element: HTMLElement): void;
    options?: Inputmask$1.Options;
}
declare const useInputMask: (props: UseInputMaskOptions) => react.RefObject<HTMLInputElement>;

type Register = UseFormRegisterReturn;
type Mask = Inputmask.Options['mask'];
type Options = Inputmask.Options;
type Input = HTMLInputElement | HTMLTextAreaElement | HTMLElement | HTMLInputElement | null;

declare const withHookFormMask: (register: Register, mask: Mask, options?: Options) => Register;

declare const withMask: (mask?: Mask, options?: Options) => (input: Input) => Input;

export { useInputMask as default, withHookFormMask, withMask };
